<?php
/*
Plugin Name: physical2virtual
Version: 2.6.b
Description: Autoconvert physical albums to virtual
Author: JanisV
*/

if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');

define('PHYSICAL2VIRTUAL_ID',       basename(dirname(__FILE__)));
define('PHYSICAL2VIRTUAL_PATH' ,    PHPWG_PLUGINS_PATH . PHYSICAL2VIRTUAL_ID . '/');
define('PHYSICAL2VIRTUAL_ADMIN',    get_root_url() . 'admin.php?page=plugin-' . PHYSICAL2VIRTUAL_ID);

add_event_handler('init', 'physical2virtual_init');
if (defined('IN_ADMIN'))
{
  add_event_handler('get_admin_plugin_menu_links', 'physical2virtual_admin_menu');
} 

function physical2virtual_init()
{
  global $conf;
  
  load_language('plugin.lang', PHYSICAL2VIRTUAL_PATH);

  $conf['physical2virtual'] = unserialize($conf['physical2virtual']);

//  add_event_handler('invalidate_user_cache', 'physical2virtual_convert');
}

function physical2virtual_convert()
{
  global $conf;

  $query = '
    SELECT name
    FROM '.CATEGORIES_TABLE.'
    WHERE dir IS NULL
  ;';  // get virtual
  $virt_cats = array_from_query($query, 'name'); 
  
  $query = '
    SELECT id, name
    FROM '.CATEGORIES_TABLE.'
    WHERE dir IS NOT NULL
  ;';  // get physical
  $result = pwg_query($query);
  while ($row = pwg_db_fetch_assoc($result))
  {
    $virt_name = $row['name'];
    $created = false;
    if (!in_array($virt_name, $virt_cats))
    {
      $parent = isset($conf['physical2virtual']['parent_cat']) ? $conf['physical2virtual']['parent_cat'] : null;
      $virt_id = create_virtual_category($virt_name, $parent)['id'];
      $created = true;

      if (isset($conf['physical2virtual']['lock_physical']) and $conf['physical2virtual']['lock_physical'])
      {
        $cat_info = get_cat_info($row['id']);
        if ($cat_info['visible'] == true)
        {
          set_cat_visible(array($row['id']), false);
        }
      }
    }
    else
    {
      // Get existen virt category ID
      $query = '
        SELECT id FROM '.CATEGORIES_TABLE.' WHERE dir IS NULL AND name = \''.pwg_db_real_escape_string($virt_name).'\'
      ;';
      list($virt_id) = pwg_db_fetch_row(pwg_query($query));
    }

    $query = '
      INSERT IGNORE INTO '.IMAGE_CATEGORY_TABLE.' (category_id, image_id)
        SELECT '.$virt_id.', image_id FROM '.IMAGE_CATEGORY_TABLE.' WHERE category_id = '.$row['id'].'
    ;';
    pwg_query($query);

    if ($created)
    {
      set_random_representant(array($virt_id));
    }
  }
}

function physical2virtual_admin_menu($menu)
{
  $menu[] = array(
    'NAME' => 'physical2virtual',
    'URL'  => PHYSICAL2VIRTUAL_ADMIN,
  );

  return $menu;
}

?>
